#pragma once
#include "../Generic/undirectednode.h"

namespace Datastructures {
	namespace Nodes {
		template <typename T>
		class LinkedListNode : public Generic::UndirectedNode<T, LinkedListNode<T>>
		{
		public:
			//Inherit Constructor from generic Undirectetd Node
			using Generic::UndirectedNode<T, LinkedListNode<T>>::UndirectedNode;
			std::shared_ptr<LinkedListNode<T>> create(T value, std::shared_ptr<LinkedListNode<T>> next = nullptr);
		private:
		};

		//Creates a new node, returning a smart pointer to a stack allocated object
		template <typename T>
		std::shared_ptr<LinkedListNode<T>> LinkedListNode<T>::create(T value, std::shared_ptr<LinkedListNode<T>> next) {
			return std::make_shared<LinkedListNode<T>>(value, next);
		}
	}
}